#ifndef PROTOCOL_WLR_DATA_CONTROL_UNSTABLE_V1_H
#define PROTOCOL_WLR_DATA_CONTROL_UNSTABLE_V1_H

#include "symgen_types.h"
extern const struct wp_interface intf_wl_seat;
extern const struct wp_interface intf_zwlr_data_control_device_v1;
extern const struct wp_interface intf_zwlr_data_control_manager_v1;
extern const struct wp_interface intf_zwlr_data_control_offer_v1;
extern const struct wp_interface intf_zwlr_data_control_source_v1;
struct req_map_zwlr_data_control_manager_v1 {
	wp_callfn_t create_data_source;
	wp_callfn_t get_data_device;
	wp_callfn_t destroy;
};
#define ZWLR_DATA_CONTROL_DEVICE_V1_ERROR_USED_SOURCE 1
struct req_map_zwlr_data_control_device_v1 {
	wp_callfn_t set_selection;
	wp_callfn_t destroy;
	wp_callfn_t set_primary_selection;
};
struct evt_map_zwlr_data_control_device_v1 {
	wp_callfn_t data_offer;
	wp_callfn_t selection;
	wp_callfn_t finished;
	wp_callfn_t primary_selection;
};
#define ZWLR_DATA_CONTROL_SOURCE_V1_ERROR_INVALID_OFFER 1
void do_zwlr_data_control_source_v1_evt_send(struct context *ctx, const char *mime_type, int fd);
void call_zwlr_data_control_source_v1_evt_send(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);
struct req_map_zwlr_data_control_source_v1 {
	wp_callfn_t offer;
	wp_callfn_t destroy;
};
struct evt_map_zwlr_data_control_source_v1 {
	wp_callfn_t send;
	wp_callfn_t cancelled;
};
void do_zwlr_data_control_offer_v1_req_receive(struct context *ctx, const char *mime_type, int fd);
void call_zwlr_data_control_offer_v1_req_receive(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);
struct req_map_zwlr_data_control_offer_v1 {
	wp_callfn_t receive;
	wp_callfn_t destroy;
};
struct evt_map_zwlr_data_control_offer_v1 {
	wp_callfn_t offer;
};

#endif /* PROTOCOL_WLR_DATA_CONTROL_UNSTABLE_V1_H */
